#ifndef __TASKLIST__
#define __TASKLIST__

#define TF_FOCUS       (1 << 1)
#define TF_ICONIFIED   (1 << 2)
#define TF_VALID       (1 << 3)

typedef struct _tagICON
{
  PIXMAP icon;
  int destroy;
} ICON,*LPICON;

typedef struct _tagTASK
{
  Window wnd;
  char *name;
  ICON icon;
  unsigned int nameLen;
  unsigned int dwFlags;
  struct _tagTASK *next;
} TASK,*LPTASK;

#define FTF_WINDOW   (1 << 1)
#define FTF_NAME     (1 << 2)
typedef struct _tagFINDTASK
{
  unsigned int dwFlags;
  Window wnd;
  const char *name;
} FINDTASK,*LPFINDTASK;

LPTASK AddTask(LPTASK *head,Window newTask,unsigned int dwFlags);
void RemoveTask(LPTASK *head,Window deadTask);
LPTASK FindTask(LPTASK head,LPFINDTASK pFindTask);
void RemoveAllTasks(LPTASK *head);
void UpdateName(LPTASK pTask);
unsigned int CountTasks(LPTASK head);
LPTASK GetTask(LPTASK head,unsigned int index);

void UnmarkAllTasks(LPTASK head);
int RemoveUnmarkedTasks(LPTASK *head);
void MarkTask(LPTASK head);
void UnmarkTask(LPTASK head);

void LoadIcon(LPTASK pTask);

#endif
